//
//  it_keyTranslator.h
//  AirClick
//
//  Created by Casey on 9/30/04.
//  Copyright 2004 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#include <Carbon/Carbon.h>
#include <CoreServices/CoreServices.h>

enum modifier_key_code {
    eModKey_Command 	= 0x37,
    eModKey_Shift		= 0x38,
    eModKey_CapsLock 	= 0x39,
    eModKey_Option		= 0x3a,
    eModKey_Control 	= 0x3b
};

@interface it_keyTranslator : NSObject
{
    KeyboardLayoutRef	mKeyboardLayout;
    UCKeyboardLayout	*muchrData;
    void				*mKCHRData;
	
	SInt32				mConvertTable[128];
    SInt32				mKeyLayoutKind;
    UInt32				mKeyTranslateState;
    UInt32				mDeadKeyState;
}

+ (id)					currentTranslator;

- (id)					initWithKeyboardLayout: (KeyboardLayoutRef) aLayout;
- (NSString *)			translateKeyCode: (short) keyCode;

- (KeyboardLayoutRef)	keyboardLayout;

- (void)				simulateASCIIKey: (UInt8) inCharCode
							withModifiers: (SInt32) inModifiers;
- (void)				simulateVirtualKey: (UInt16) inCharCode
							withModifiers: (SInt32) inModifiers;
- (void)				simulateVolUpKey;
- (void)				simulateVolDownKey;

@end
